; -*- Scheme -*-

; this file was initialy written for Trapas3D modeler
; thus not eliminated tui (Trapas gUI) prefix

(use-modules (ice-9 session)
	     (ice-9 regex))

(define (find-lower-bound string pos)
  (if (<= pos 0) 
      0
      (case (string-ref string (-1+ pos))
	((#\space  #\ht #\( #\)) pos)
	(else (find-lower-bound string (-1+ pos))))))

(define (string-common start end s1 s2)
  (cond
   ((>= start end) 
    start)
   ((eq? (string-ref s1 start) (string-ref s2 start))
    (string-common (1+ start) end s1 s2))
   (else start)))

(define (find-common string-list minimum so-far)
  (cond
   ((or (null? (cdr string-list))) so-far)
   (else
    (let* ((s1 (car string-list))
	   (s2 (cadr string-list))
	   (ml (min (string-length s1) (string-length s2))))

    (find-common (cdr string-list)
		 minimum
		 (min so-far 
		      (string-common minimum ml s1 s2)))))))

(define completions '())

(define-public tui-completion-portion 7)

(define-public (tui-complete-clear)
  (set! completions '()))

(define-public (tui-complete str pos)
  (let ((return #f))
    (cond
     ((null? completions)
      (let* ((start  (find-lower-bound str pos))
	     (substr (substring str start pos))
	     (sublen (- pos start)))

	(set! completions
	      (map symbol->string
		   (apropos-internal 
		    (string-append "^" (regexp-quote substr)))))
	(cond
	 ((null? completions))
	 ((null? (cdr completions))
	  (set! return (substring (car completions) sublen))
	  (set! completions '()))
	 (else
	  (let ((fc	(find-common completions sublen 10000)))
	    (if (> fc sublen) 
		(set! return (substring (car completions) sublen fc))))))))
     ((not completions)
      (set! completions '())
      (set! return '())))

    (cond
     ((not return)
      (let ((size  (min (length completions)
			tui-completion-portion)))
	(set! return (list-head completions size))
	(set! completions (list-tail completions size))
	(and (null? completions) 
	     (set! completions #f)))))
    return))
	   

	  

  
