; -*- Scheme -*-

(define string string-append)

	;;; turn on line numbers when reading files (debugging only)
(and tulpas-developers-mode (read-enable 'positions))

(define tulpas-rules-dir (string tulpas-data-dir "/rules"))

(define user-home (getenv "HOME"))
(define tulpas-user-dir (string user-home "/.gtulpas"))
(define tulpas-user-rules-dir (string tulpas-user-dir "/rules"))
(define tulpas-user-init (string tulpas-user-dir "/init-user.scm"))

(set! %load-path
      (cons tulpas-user-dir
	    (cons (string tulpas-data-dir "/scheme")
		  %load-path)))

(load "utilities.scm")
(load "debug.scm")

(load "skins.scm")
(load "fyjik-skins.scm")
(load "cues.scm")

(load "utilities-pool.scm")
(load "utilities-table.scm")
(load "utilities-8ball.scm")

; Load all games from 

(scan-directory-for-games tulpas-rules-dir)
(and (file-exists? tulpas-user-rules-dir)
     (file-is-directory? tulpas-user-rules-dir)
     (scan-directory-for-games tulpas-user-rules-dir))

; load user-specific init

(and (file-exists? tulpas-user-init)
     (load tulpas-user-init))
	 
(DebugDisplay "-*- End of scheme init -*-")


