; -*- Scheme -*-

(define 8ball-names
  (vector
   "cue ball"
   "1. (yellow) ball"
   "2. (blue) ball"
   "3. (red) ball"
   "4. (purple) ball"
   "5. (orange) ball"
   "6. (gren) ball"
   "7. (brown) ball"
   "8. (black) ball"

   "9. (yellow strip) ball"
   "10. (blue strip) ball"
   "11. (red strip) ball"
   "12. (purple strip) ball"
   "13. (orange strip) ball"
   "14. (green strip) ball"
   "15. (brown strip) ball"))

(define (8ball-name x)
  (vector-ref 8ball-names x))


(define (8ball-skins n)
  (for-each
   (lambda (x)
     (apply ball-set-skin (car x) (8ball-name (car x)) (cdr x)))

   (list-tail
    '((15 white-ball-brown-strip pocket-billiard-ball)
      (14 white-ball-green-strip pocket-billiard-ball)
      (13 white-ball-orange-strip pocket-billiard-ball)
      (12 white-ball-purple-strip pocket-billiard-ball)
      (11 white-ball-red-strip pocket-billiard-ball)
      (10 white-ball-blue-strip pocket-billiard-ball)
      ( 9 white-ball-yellow-strip pocket-billiard-ball)

      ( 8 black-ball pocket-billiard-ball)

      ( 7 brown-ball pocket-billiard-ball)
      ( 6 green-ball pocket-billiard-ball)
      ( 5 orange-ball pocket-billiard-ball)
      ( 4 purple-ball pocket-billiard-ball)
      ( 3 red-ball pocket-billiard-ball)
      ( 2 blue-ball pocket-billiard-ball)
      ( 1 yellow-ball pocket-billiard-ball)

      ( 0 white-ball pocket-billiard-ball))
     
    (- 16 (if (number? n) n 16)))))

(define 8ball-solids-list '(1 2 3 4 5 6 7))
(define 8ball-stripes-list '(9 10 11 12 13 14 15))

(define 8ball-cue-ball 0)
(define 8ball-8ball 8)

(define (8ball-solid? x)
  (and (< 0 x) (< x 8)))

(define (8ball-stripe? x)
  (and (< 8 x) (< x 16)))

